From 9964262630a98b2f6b6d3309b306b2bb0af70410 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 25 2020 23:44:11 +0000
Subject: [PATCH 196/2232] Implement and test some more fallible return types


---

diff --git a/gen/write.rs b/gen/write.rs
index a4e2eb2..72962f2 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -297,7 +297,7 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
     if efn.throws {
         write!(out, "::rust::Str::Repr ");
     } else {
-        write_extern_return_type(out, &efn.ret, types);
+        write_extern_return_type_space(out, &efn.ret, types);
     }
     for name in out.namespace.clone() {
         write!(out, "{}$", name);
@@ -317,7 +317,7 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
         if !efn.args.is_empty() {
             write!(out, ", ");
         }
-        write_return_type(out, &efn.ret);
+        write_indirect_return_type_space(out, efn.ret.as_ref().unwrap());
         write!(out, "*return$");
     }
     writeln!(out, ") noexcept {{");
@@ -340,15 +340,15 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
     }
     if indirect_return {
         write!(out, "new (return$) ");
-        write_type(out, efn.ret.as_ref().unwrap());
+        write_indirect_return_type(out, efn.ret.as_ref().unwrap());
         write!(out, "(");
-    } else if let Some(ret) = &efn.ret {
+    } else if efn.ret.is_some() {
         write!(out, "return ");
-        match ret {
-            Type::Ref(_) => write!(out, "&"),
-            Type::Str(_) => write!(out, "::rust::Str::Repr("),
-            _ => {}
-        }
+    }
+    match &efn.ret {
+        Some(Type::Ref(_)) => write!(out, "&"),
+        Some(Type::Str(_)) if !indirect_return => write!(out, "::rust::Str::Repr("),
+        _ => {}
     }
     write!(out, "{}$(", efn.ident);
     for (i, arg) in efn.args.iter().enumerate() {
@@ -378,7 +378,7 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
     match &efn.ret {
         Some(Type::RustBox(_)) => write!(out, ".into_raw()"),
         Some(Type::UniquePtr(_)) => write!(out, ".release()"),
-        Some(Type::Str(_)) => write!(out, ")"),
+        Some(Type::Str(_)) if !indirect_return => write!(out, ")"),
         _ => {}
     }
     if indirect_return {
@@ -405,7 +405,7 @@ fn write_rust_function_decl(out: &mut OutFile, efn: &ExternFn, types: &Types) {
     if efn.throws {
         write!(out, "::rust::Str::Repr ");
     } else {
-        write_extern_return_type(out, &efn.ret, types);
+        write_extern_return_type_space(out, &efn.ret, types);
     }
     for name in out.namespace.clone() {
         write!(out, "{}$", name);
@@ -542,7 +542,34 @@ fn indirect_return(efn: &ExternFn, types: &Types) -> bool {
         .map_or(false, |ret| efn.throws || types.needs_indirect_abi(ret))
 }
 
-fn write_extern_return_type(out: &mut OutFile, ty: &Option<Type>, types: &Types) {
+fn write_indirect_return_type(out: &mut OutFile, ty: &Type) {
+    match ty {
+        Type::RustBox(ty) | Type::UniquePtr(ty) => {
+            write_type_space(out, &ty.inner);
+            write!(out, "*");
+        }
+        Type::Ref(ty) => {
+            if ty.mutability.is_none() {
+                write!(out, "const ");
+            }
+            write_type(out, &ty.inner);
+            write!(out, " *");
+        }
+        Type::Str(_) => write!(out, "::rust::Str::Repr"),
+        _ => write_type(out, ty),
+    }
+}
+
+fn write_indirect_return_type_space(out: &mut OutFile, ty: &Type) {
+    write_indirect_return_type(out, ty);
+    match ty {
+        Type::RustBox(_) | Type::UniquePtr(_) | Type::Ref(_) => {}
+        Type::Str(_) => write!(out, " "),
+        _ => write_space_after_type(out, ty),
+    }
+}
+
+fn write_extern_return_type_space(out: &mut OutFile, ty: &Option<Type>, types: &Types) {
     match ty {
         Some(Type::RustBox(ty)) | Some(Type::UniquePtr(ty)) => {
             write_type_space(out, &ty.inner);
@@ -623,6 +650,10 @@ fn write_type(out: &mut OutFile, ty: &Type) {
 
 fn write_type_space(out: &mut OutFile, ty: &Type) {
     write_type(out, ty);
+    write_space_after_type(out, ty);
+}
+
+fn write_space_after_type(out: &mut OutFile, ty: &Type) {
     match ty {
         Type::Ident(_) | Type::RustBox(_) | Type::UniquePtr(_) | Type::Str(_) => write!(out, " "),
         Type::Ref(_) => {}
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 5d0598e..492fc91 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -36,8 +36,11 @@ pub mod ffi {
         fn c_try_return_void() -> Result<()>;
         fn c_try_return_primitive() -> Result<usize>;
         fn c_fail_return_primitive() -> Result<usize>;
-        fn c_try_return_string() -> Result<UniquePtr<CxxString>>;
-        fn c_fail_return_string() -> Result<UniquePtr<CxxString>>;
+        fn c_try_return_box() -> Result<Box<R>>;
+        fn c_try_return_ref(s: &String) -> Result<&String>;
+        fn c_try_return_str(s: &str) -> Result<&str>;
+        fn c_try_return_rust_string() -> Result<String>;
+        fn c_try_return_unique_ptr_string() -> Result<UniquePtr<CxxString>>;
     }
 
     extern "Rust" {
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 6ca27db..6384ac1 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -98,12 +98,16 @@ size_t c_try_return_primitive() { return 2020; }
 
 size_t c_fail_return_primitive() { throw std::logic_error("logic error"); }
 
-std::unique_ptr<std::string> c_try_return_string() {
-  return std::unique_ptr<std::string>(new std::string("ok"));
-}
+rust::Box<R> c_try_return_box() { return c_return_box(); }
+
+const rust::String &c_try_return_ref(const rust::String &s) { return s; }
+
+rust::Str c_try_return_str(rust::Str s) { return s; }
+
+rust::String c_try_return_rust_string() { return c_return_rust_string(); }
 
-std::unique_ptr<std::string> c_fail_return_string() {
-  throw std::logic_error("logic error getting string");
+std::unique_ptr<std::string> c_try_return_unique_ptr_string() {
+  return c_return_unique_ptr_string();
 }
 
 extern "C" C *cxx_test_suite_get_unique_ptr() noexcept {
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 7f45287..e0e7624 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -39,7 +39,10 @@ void c_take_unique_ptr_string(std::unique_ptr<std::string> s);
 void c_try_return_void();
 size_t c_try_return_primitive();
 size_t c_fail_return_primitive();
-std::unique_ptr<std::string> c_try_return_string();
-std::unique_ptr<std::string> c_fail_return_string();
+rust::Box<R> c_try_return_box();
+const rust::String &c_try_return_ref(const rust::String &);
+rust::Str c_try_return_str(rust::Str);
+rust::String c_try_return_rust_string();
+std::unique_ptr<std::string> c_try_return_unique_ptr_string();
 
 } // namespace tests
diff --git a/tests/test.rs b/tests/test.rs
index 87a18ad..6a6fc3e 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -38,17 +38,26 @@ fn test_c_return() {
             .to_str()
             .unwrap()
     );
+}
 
+#[test]
+fn test_c_try_return() {
     assert_eq!((), ffi::c_try_return_void().unwrap());
     assert_eq!(2020, ffi::c_try_return_primitive().unwrap());
     assert_eq!(
         "logic error",
         ffi::c_fail_return_primitive().unwrap_err().what(),
     );
-    assert_eq!("ok", ffi::c_try_return_string().unwrap().as_ref().unwrap());
+    assert_eq!(2020, *ffi::c_try_return_box().unwrap());
+    assert_eq!("2020", *ffi::c_try_return_ref(&"2020".to_owned()).unwrap());
+    assert_eq!("2020", ffi::c_try_return_str("2020").unwrap());
+    assert_eq!("2020", ffi::c_try_return_rust_string().unwrap());
     assert_eq!(
-        "logic error getting string",
-        ffi::c_fail_return_string().unwrap_err().what(),
+        "2020",
+        ffi::c_try_return_unique_ptr_string()
+            .unwrap()
+            .as_ref()
+            .unwrap()
     );
 }
 

